/************************************************************************************************
*												*
*					PWM SOURCEFILE						*
*				      ==================					*
*												*
*	Version 	0.9									*
*											*
************************************************************************************************/

/*** Libarys / Definitions *********************************************************************/

#include <avr/io.h>
#include <avr/pgmspace.h>

#include "PWM.h"



/**** Linear Fading ****************************************************************************/

unsigned int PWM_table[128] PROGMEM= {	0,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,3,
					3,3,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,
					7,7,7,8,8,9,9,10,10,11,11,12,13,13,
					14,15,16,17,18,19,20,21,22,23,24,
					26,27,29,30,32,34,36,38,40,42,44,
					47,49,52,55,58,61,65,68,72,76,80,
					85,90,95,100,105,111,117,124,131,
					138,146,154,162,171,181,191,202,213,
					225,237,251,264,279,295,311,328,
					347,366,386,408,431,454,480,506,535,
					564,596,629,664,701,740,781,825,870,
					919,970,1024};



/**** Routines *********************************************************************************/
 
void PWM_init(void){
   	
    	TCCR1A = (1<<COM1A1)|(1<<WGM11)|(1<<WGM10); 		// 10Bit, fast PWM, Inv

   	TCCR1B = (1<<WGM12);
 
    	TCCR1B &= ~0x7;        					// CLR ClK-Einstellungen
	
	TCCR1B |= 1;           					// CLK = 1

	PWM_set(0x00);
}


void PWM_set(unsigned char pwm){

	if(pwm > 127) pwm = 127;
	OCR1A = pgm_read_word(PWM_table+pwm);			// Setze entsprechenden Wert
}



